######################################################################
# gzip.inc.pl - This is PyukiWiki, yet another Wiki clone.
# gzip Plugin
#
# $Id: gzip.inc.pl,v 1.2 2006/01/11 23:14:26 papu Exp $
#
# "PyukiWiki" version 0.1.6-alpha3 $$
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# This is extented plugin.
# To use this plugin, rename to 'gzip.inc.cgi'
######################################################################

#$::gzip_path="/bin/gzip";
#$::gzip_path="/usr/bin/gzip";
#$::gzip_path="/usr/bin/gzip -1 -f";

$gzip_command="gzip";

sub plugin_gzip_init {
	# auto search too slow...
	if($::gzip_path eq '') {
		my $forceflag="";
		my $fastflag="";
		foreach(split(/:/,$ENV{PATH})) {
			if(-x "$_/$gzip_command") {
				$::gzip_path="$_/$gzip_command" ;
				if(open(PIPE,"$::gzip_path --help 2>&1|")) {
					foreach(<PIPE>) {
						$forceflag="--force" if(/(\-\-force)/);
						$fastflag="--fast" if(/(\-\-fast)/);
					}
					close(PIPE);
				}
			}
		}
		$gzip_path="$::gzip_path $fastflag $forceflag";
		$::debug.="gzip.inc.cgi: auto detect gzip path : \"$gzip_path\"\n";
	}
	if ($::gzip_path ne '') {
		if(($ENV{'HTTP_ACCEPT_ENCODING'}=~/gzip/)) {
			if($ENV{'HTTP_ACCEPT_ENCODING'}=~/x-gzip/) {
				$::gzip_header="Content-Encoding: x-gzip\n";
			} else {
				$::gzip_header="Content-Encoding: gzip\n";
			}
		}
	}

	return('http_header'=>$::gzip_header,
		   'init'=>$::gzip_header eq '' ? 0 : 11,
		   'func'=>'content_output');
}

sub content_output {
	my ($http_header,$body)=@_;
	print $http_header;
	if ($::gzip_header ne '') {
		open(STDOUT,"| $::gzip_path");
		$body=~s/<!--HTMLEND-->/ Compressed<!--HTMLEND-->/g;
	}
	print $body;
}

1;
