######################################################################
# perlpod.pl - This is PyukiWiki, yet another Wiki clone.
# perlpod plugin
#
# $Id: perlpod.inc.pl,v 1.4 2006/01/12 22:50:58 papu Exp $
#
# "PyukiWiki" version 0.1.6-alpha3 $$
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################

sub plugin_perlpod_action {
	my $file;
	my $dir;
	$file=$::form{file};
	return if($file=~/\.\./ || $file=~/^\// || $file=~/[|><%'"]/);

	if($::form{dir} eq 'plugin') {
		$dir=$::plugin_dir;
	} elsif($::form{dir} eq 'explugin' || $::form{dir} eq 'module') {
		$dir=$::explugin_dir;
	} elsif($::form{dir} eq 'skin') {
		$dir=$::skin_dir;
	} elsif($::form{dir} eq 'res' || $::form{dir} eq 'resource') {
		$dir=$::res_dir;
	} else {
		$dir=$::data_home;
	}

	return('msg'=>"\t$::$file"
		,'body'=>&perlpod("$dir/$file"));
}

sub plugin_perlpod_convert {
	my $file;
	my $dir;

	my @args=split(/,/,shift);
	$file=$args[0];
	$notitle=$args[1];

	return if($file=~/\.\./ || $file=~/^\// || $file=~/[|><%'"]/);

	if($::form{dir} eq 'plugin') {
		$dir=$::plugin_dir;
	} elsif($::form{dir} eq 'explugin' || $::form{dir} eq 'module') {
		$dir=$::explugin_dir;
	} elsif($::form{dir} eq 'skin') {
		$dir=$::skin_dir;
	} elsif($::form{dir} eq 'res' || $::form{dir} eq 'resource') {
		$dir=$::res_dir;
	} else {
		$dir=$::data_home;
	}

	return(&perlpod("$dir/$file",$notitle ne '' ? "notitle" : ""));
}

sub getperlpath{
	my $perlpath;
	if(open(R,"$0")) {
		$perlpath=<R>;
		close(R);
		$perlpath=~s/#!//g;
		$perlpath=~s/-//g;
		$perlpath=~s/ //g;
		$perlpath=~s/[\r\n]//g;
		return $perlpath;
	}
	return '';
}

sub perlpod {
	use Pod::Html;
	my $perlpath=&getperlpath;
	my $file=shift;
	my $notitle=shift;

	my $pod;
	my $tmp;
	return("perl path can't found") if($perlpath eq '');

	return("File not found : $file") unless(-r $file);

	if($ENV{TEMP} ne '') {
		$tmp=$ENV{TEMP};
	} elsif($ENV{TMP} ne '') {
		$tmp=$ENV{TMP};
	} else {
		$tmp="/tmp";
	}

	my $exec="$perlpath -S pod2html -cachedir=$tmp $file";
	if(open(PIPE,"$exec |")) {
		foreach(<PIPE>) {
			$pod.=$_;
		}
		close(PIPE);
	} else {
		return("Can't exec $exec");
	}
	my $body;
	foreach(split(/\n/,$pod)) {
		s/^<!.*//g;
		s/<(html|\/html).*//g;
		s/<(body|\/body).*//g;
		s/<(link|\/link).*//g;
		s/<\/h4>/<\/h6>/g;
		s/<\/h3>/<\/h5>/g;
		s/<\/h2>/<\/h4>/g;
		s/<\/h1>/<\/h3>/g;
		s/<\/title>/<\/h2>/g;
		s/<h4>/<h6>/g;
		s/<h3>/<h5>/g;
		s/<h2>/<h4>/g;
		s/<h1>/<h3>/g;
		s/<title>/<h2>/g;
		next if($_ eq '');
		next if($notitle ne '' && /<h2.*>/);
		$body.="$_\n";
	}
	return($body);
}

1;
__END__

=head1 NAME

perlpod.inc.pl - PyukiWiki Plugin

=head1 SYNOPSIS

 ?cmd=perlpod&file=perl script file or pod file.
 #perlpod(perl script file or pod file.)

=head1 DESCRIPTION

View perl document of pod

A directory cannot be specified because of the measure against security.

Automatically Recursive search of the bottom of the directory setup by pyukiwiki.ini.cgi.

=head1 AUTHOR

=over 4

=item Nanami

L<http://lineage.netgamers.jp/>

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=head1 LICENSE

Copyright (C) 2006 by Nanami.

Copyright (C) 2006 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
