######################################################################
# RSS.pm - This is PyukiWiki, yet another Wiki clone.
# from YukiWiki
#
# $Id: RSS.pm,v 1.13 2006/01/18 07:34:09 papu Exp $
#
# "Yuki::DiffText" version 0.3 $$
# Author: Hiroshi Yuki http://www.hyuki.com/
#
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################

package Yuki::RSS;
use strict;
use vars qw($VERSION);

$VERSION = '0.3';



# The constructor.
sub new {
    my ($class, %hash) = @_;
    my $self = {
        version => $hash{version},
        encoding => $hash{encoding},
        channel => { },
        items => [],
    };
    return bless $self, $class;
}

# Setting channel.
sub channel {
    my ($self, %hash) = @_;
    foreach (keys %hash) {
        $self->{channel}->{$_} = $hash{$_};
    }
    return $self->{channel};
}

# Adding item.
sub add_item {
    my ($self, %hash) = @_;
    push(@{$self->{items}}, \%hash);
    return $self->{items};
}

# 
sub as_string {
    my ($self) = @_;
    my $doc = <<"EOD";
<?xml version="1.0" encoding="$self->{encoding}" ?>

<rdf:RDF
 xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
 xmlns="http://purl.org/rss/1.0/"
 xmlns:dc="http://purl.org/dc/elements/1.1/"
>

<channel rdf:about="$self->{channel}->{link}">
 <title>$self->{channel}->{title}</title>
 <link>$self->{channel}->{link}</link>
 <description>$self->{channel}->{description}</description>
 <items>
  <rdf:Seq>
   @{[
    map {
     qq{<rdf:li rdf:resource="$_->{link}" />}
    } @{$self->{items}}
   ]}
  </rdf:Seq>
 </items>
</channel>
@{[
 map {
  qq{
   <item rdf:about="$_->{link}">
    <title>$_->{title}</title>
    <link>$_->{link}</link>
    <description>$_->{description}</description>
    <dc:date>$_->{dc_date}</dc:date>
   </item>
  }
 } @{$self->{items}}
]}
</rdf:RDF>
EOD
}

1;
