######################################################################
# sitemap.pl - This is PyukiWiki, yet another Wiki clone.
# sitemap plugin
#
# $Id: sitemap.inc.pl,v 1.14 2006/01/19 12:08:29 papu Exp $
# Author: Nanami http://lineage.netgamers.jp/
#
# "PyukiWiki" version 0.1.6-alpha5-p2 $$
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# ȥޥåץץ饰ǤϡŪפ˥桼ʥӥ
# 䤹ץ饰Ǥ
#
# ҤˤϡʲΤ褦ʥ롼뤬ޤ
#
# MenuBarǤϰʲΤ褦˵Ҥ
# ***̾
# [[WikiName]]
# [[ڡ]]
# (WikiNameǤưޤ)
#
# MenuBarϿ줿ڡǤϡʲΤ褦˵Ҥ
# -[[WikiName]] (WikiNameǤưޤ)
# -[[ڡ]]~
# --[[ڡ]]~
# ---[[ڡ]]~
# -[[?cmd=ץ饰&.....]]~
#
# p.s. [[>http://www.yahoo.co.jp/]] 󥯤ϤϤޤ
#
# Ȥ
# ?cmd=sitemap
# http://lineage.netgamers.jp/?cmd=sitemap
#
# ܤwikiΥߤƤ
# http://lineage.netgamers.jp/?cmd=adminedit&mypage=MenuBar
# http://lineage.netgamers.jp/?cmd=adminedit&mypage=%bd%d0%b2%d4%a4%ae%a5%ea%a5%b9%a5%c8
# http://lineage.netgamers.jp/?cmd=edit&mypage=%bd%d0%b2%d4%a4%aeFPK%b9%b6%ce%ac
######################################################################

sub plugin_sitemap_action {
	my $prev = '';
	my $char = '';
	my $idx = 1;
	my $menubar=$::MenuBar;
	my $name;
	my $menucount=0;
	my $submenucount=0;
	my $menu;
	my $basepage;
	my $nextpage;
	my $nestcount=0;
	my $body="*$::resource{sitemap_plugin_title}\n";

	foreach $basepage(split(/\n/,$::database{$menubar})) {
		# MenuBar ***ιܤФ
		if ($basepage=~/^(\*{1,5})(.+)/) {
			$name=$basepage;
			$name=~s/^(\*{1,5})//g;
			$name=&plugin_sitemap_trim($name);
			$menucount++;
			push(@sitemap,$name);
		#  MenuBar֥饱åȤФ
		}elsif($basepage=~/$::bracket_name/ && $basepage!~/>(http:|https:|ftp:|mailto:|\?)/
			&& $basepage!~/($::interwiki_name1|$::interwiki_name2)/) {
			$basepage=~s/$::bracket_name/$1/g;
			$basepage=~s/.*>//g if($basepage=~/>/);
			$basepage=&plugin_sitemap_trim($basepage);
			$submenucount++;
			$sitemap{$name}.=sprintf("%05d\t%05d\t%05d\t%s\n",$menucount,$submenucount,0,$basepage);
			$nextmenucount=0;
			# MenuBarФڡ顢٥ΥڡФ


			foreach $subpage(split(/\n/,$::database{$basepage})) {
				if($subpage=~/-{1,3}$::bracket_name/ && $subpage!~/>(http:|https:|ftp:|mailto:|\?)/
					&& $subpage!~/($::interwiki_name1|$::interwiki_name2)/
					|| $subpage=~/>\?cmd=.*/ && $subpage =~ /^-\[\[(.*?)\]\]/) {
					$nextpage=$subpage;
					$nextpage=~s/-{1,3}$::bracket_name/$1/g;
					$nextpage=&plugin_sitemap_trim($nextpage);
					$nextpage=~s/.*>//g if($nextpage=~/>/ && $nextpage !~/\?cmd=/);
					$nextmenucount++;
					$sitemap{$name}.=sprintf("%05d\t%05d\t%05d\t%s\n",$menucount,$submenucount,$nextmenucount,$nextpage);
				}
			}
		}
	}
	foreach $menu(@sitemap) {
		if($sitemap{$menu} ne '') {
			$body.="-''$menu''\n";
			foreach(split(/\n/,$sitemap{$menu})) {
				($menucount,$submenucount,$nextmenucount,$page)=split(/\t/,$_);
				$page=~s/[\r|\n]//g;
				if(&is_readable($page)) {
					if($nextmenucount+0 eq 0) {
						$body.="--[[$page]]\n";
					} else {
						$body.="---[[$page]]\n";
					}
				}
			}
		}
	}
	$body=&text_to_html($body,0);

	return ('msg' => "\t$::resource{sitemap_plugin_title}", 'body' => $body);
}

sub plugin_sitemap_trim {
	my($name)=@_;
	$name=~s/\~//g;
	$name=~s/[\r|\n]//g;
	$name=~s/\ \/\/\ \#.*//g;	# debug
	return $name;
}
1;
__END__
=head1 NAME

sitemap.inc.pl - PyukiWiki Plugin

=head1 SYNOPSIS

 ?cmd=sitemap

=head1 DESCRIPTION

Make navigation of the "explicit" caller easy to carry out.

=head1 USAGE

=head2 MenuBar

=item MenuBar

Written for MenuBar

 ***Item Name
 [[WikiName]]
 [[pagename]]

It does not move only by WikiName.

=item Each page

The page registered into MenuBar describes as follows.

 -[[WikiName]] (It does not move only by WikiName.)
 -[[pagename]]~
 --[[pagename]]~
 ---[[pagename]]~
 -[[?cmd=plugin&.....]]~

=back

=head1 SETTING

=head2 pyukiwiki.ini.cgi

=over 4

=item $::use_SiteMap

0:List only, 1:List and usually, sitemap.

=back

=head1 SEE ALSO

=over 4

=item PyukiWiki/Plugin/Standard/sitemap

L<http://pyukiwiki.sourceforge.jp/cgi-bin/w/PyukiWiki/Plugin/Standard/sitemap/>

=item PyukiWiki CVS

L<http://cvs.sourceforge.jp/cgi-bin/viewcvs.cgi/pyukiwiki/PyukiWiki-Devel/plugin/sitemap.inc.pl>

=back

=head1 AUTHOR

=over 4

=item Nanami

L<http://lineage.netgamers.jp/>

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=head1 LICENSE

Copyright (C) 2005 by Nanami.

Copyright (C) 2006 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
