######################################################################
# Search.pm - This is PyukiWiki, yet another Wiki clone.
#
# $Id: Search.pm,v 1.15 2006/01/19 12:10:15 papu Exp $
#
# "Nana::Search" version 0.3 $$
# Author: Nanami http://lineage.netgamers.jp/
#
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# ܸ줢ޤ򤹤뤿Υ⥸塼ǤEUC
######################################################################

package	Nana::Search;
use 5.005;
use strict;
use vars qw($VERSION);
$VERSION = '0.3';
require Exporter;
use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
@ISA = qw(Exporter);
@EXPORT_OK = qw($VERSION);
@EXPORT = qw(Search);
%EXPORT_TAGS = ( all => [ @EXPORT_OK, @EXPORT ] );

$::Search_EUCPRE = qr{(?<!\x8F)};
$::Search_EUCPOST = qr{
	(?=
	(?:[\xA1-\xFE][\xA1-\xFE])* # JIS X 0208  0ʸʾ³
	(?:[\x00-\x7F\x8E\x8F]|\z)  # ASCII, SS2, SS3 ޤϽü
	)
}x;

sub Search {
	my($text,$wd)=@_;
	my $search;
	my $keyword;

	$search=&Z2H($text);
	if($::_SEARCH{$wd} eq '') {
		$keyword=&Z2H($wd);
		$::_SEARCH{$wd}=$keyword;
	} else {
		$keyword=$::_SEARCH{$wd};
	}
	return 0 if($keyword eq '');
	return 1 if($search =~ /$::Search_EUCPRE\Q$keyword\E$::Search_EUCPOST/i);
	return 0;
}

sub Z2H {
	my ($parm)=@_;

	$parm=~s/$::Search_EUCPRE\xa1(\xaa|\xc9|\xf4|\xf0|\xf3|\xf5|\xc7|\xca|\xcb|\xf6|\xdc|\xa4|\xdd|\xa5|\xbf|\xa7|\xa2)$::Search_EUCPOST//g;
	$parm=~s/$::Search_EUCPRE\xa1(\xa8|\xe3|\xe1|\xe4|\xa9|\xf7|\xce|\xef|\xcf|\xb0|\xb2|\xc6|\xd0|\xc3|\xd1|\xd1|\xa3)$::Search_EUCPOST//g;
	$parm=~s/[\x21-\x2f|\x3a-\x40|\x5b-\x60|\x7b-\x7f]//g;
	$parm=~s/$::Search_EUCPRE\xa5\xa4$::Search_EUCPOST/\r/g;
	$parm=~s/$::Search_EUCPRE\xa4([\xa1-\xfe])$::Search_EUCPOST/\xa5$1/g;
	$parm=~s/\r/\xa5\xa4/g;
	$parm=~s/$::Search_EUCPRE\xa5(\xa1|\xa3|\xa5|\xa7|\xa9|\xc3)$::Search_EUCPOST/"\xa5" . pack('C',unpack('C',$1)+1)/eg;
	$parm=~s/\xa5\xf0/\xa5\xa4/g;
	$parm=~s/\xa5\xf1/\xa5\xa8/g;
	$parm=~s/$::Search_EUCPRE(\xa3)(.)$::Search_EUCPOST/pack('C',unpack('C',$2)-128)/eg;
	$parm=~tr/A-Z/a-z/;
	return $parm;
}

1;
__END__

